Index: drivers/mtd/devices/blkmtd.c
===================================================================
RCS file: /cvsroot/ts-7200/dist/linux24/drivers/mtd/devices/blkmtd.c,v
retrieving revision 1.1
retrieving revision 1.3
diff -u -r1.1 -r1.3
--- drivers/mtd/devices/blkmtd.c	22 Jul 2004 19:49:46 -0000	1.1
+++ drivers/mtd/devices/blkmtd.c	3 Nov 2004 00:04:43 -0000	1.3
@@ -1,5 +1,5 @@
 /*
- * $Id: blkmtd.c,v 1.1 2004/07/22 19:49:46 joff Exp $
+ * $Id: blkmtd.c,v 1.3 2004/11/03 00:04:43 joff Exp $
  *
  * blkmtd.c - use a block device as a fake MTD
  *
@@ -12,11 +12,8 @@
  * How it works:
  *	The driver uses raw/io to read/write the device and the page
  *	cache to cache access. Writes update the page cache with the
- *	new data and mark it dirty and add the page into a kiobuf.
- *	When the kiobuf becomes full or the next extry is to an earlier
- *	block in the kiobuf then it is flushed to disk. This allows
- *	writes to remained ordered and gives a small and simple outgoing
- *	write cache.
+ *	new data and mark it dirty and add the page into a BIO which
+ *	is then written out.
  *
  *	It can be loaded Read-Only to prevent erases and writes to the
  *	medium.
@@ -27,20 +24,12 @@
 #include <linux/module.h>
 #include <linux/fs.h>
 #include <linux/blkdev.h>
-#include <linux/iobuf.h>
-#include <linux/slab.h>
+#include <linux/bio.h>
 #include <linux/pagemap.h>
 #include <linux/list.h>
+#include <linux/init.h>
 #include <linux/mtd/mtd.h>
 
-#ifdef CONFIG_MTD_DEBUG
-#ifdef CONFIG_PROC_FS
-#  include <linux/proc_fs.h>
-#  define BLKMTD_PROC_DEBUG
-   static struct proc_dir_entry *blkmtd_proc;
-#endif
-#endif
-
 
 #define err(format, arg...) printk(KERN_ERR "blkmtd: " format "\n" , ## arg)
 #define info(format, arg...) printk(KERN_INFO "blkmtd: " format "\n" , ## arg)
@@ -48,17 +37,15 @@
 #define crit(format, arg...) printk(KERN_CRIT "blkmtd: " format "\n" , ## arg)
 
 
-/* Default erase size in KiB, always make it a multiple of PAGE_SIZE */
+/* Default erase size in K, always make it a multiple of PAGE_SIZE */
 #define CONFIG_MTD_BLKDEV_ERASESIZE (128 << 10)	/* 128KiB */
-#define VERSION "1.10"
+#define VERSION "$Revision: 1.3 $"
 
 /* Info for the block device */
 struct blkmtd_dev {
 	struct list_head list;
-	struct block_device *binding;
+	struct block_device *blkdev;
 	struct mtd_info mtd_info;
-	struct kiobuf *rd_buf, *wr_buf;
-	long iobuf_locks;
 	struct semaphore wrbuf_mutex;
 };
 
@@ -91,136 +78,145 @@
 MODULE_PARM_DESC(sync, "1=Synchronous writes");
 
 
-/**
- * read_pages - read in pages via the page cache
- * @dev: device to read from
- * @pagenrs: list of page numbers wanted
- * @pagelst: storage for struce page * pointers
- * @pages: count of pages wanted
- *
- * Read pages, getting them from the page cache if available
- * else reading them in from disk if not. pagelst must be preallocated
- * to hold the page count.
- */
-static int read_pages(struct blkmtd_dev *dev, int pagenrs[], struct page **pagelst, int pages)
+/* completion handler for BIO reads */
+static int bi_read_complete(struct bio *bio, unsigned int bytes_done, int error)
 {
-	kdev_t kdev;
-	struct page *page;
-	int cnt = 0;
-	struct kiobuf *iobuf;
-	int err = 0;
+	if (bio->bi_size)
+		return 1;
 
-	if(!dev) {
-		err("read_pages: PANIC dev == NULL");
-		return -EIO;
-	}
-	kdev = to_kdev_t(dev->binding->bd_dev);
-
-	DEBUG(2, "read_pages: reading %d pages\n", pages);
-	if(test_and_set_bit(0, &dev->iobuf_locks)) {
-		err = alloc_kiovec(1, &iobuf);
-		if (err) {
-			crit("cant allocate kiobuf");
-			return -ENOMEM;
-		}
-#if LINUX_VERSION_CODE < KERNEL_VERSION(2,4,4)
-		iobuf->blocks = kmalloc(KIO_MAX_SECTORS * sizeof(unsigned long), GFP_KERNEL);
-		if(iobuf->blocks == NULL) {
-			crit("cant allocate iobuf blocks");
-			free_kiovec(1, &iobuf);
-			return -ENOMEM;
-		}
-#endif
-	} else {
-		iobuf = dev->rd_buf;
-	}
+	complete((struct completion*)bio->bi_private);
+	return 0;
+}
 
-	iobuf->nr_pages = 0;
-	iobuf->length = 0;
-	iobuf->offset = 0;
-	iobuf->locked = 1;
-	
-	for(cnt = 0; cnt < pages; cnt++) {
-		page = grab_cache_page(dev->binding->bd_inode->i_mapping, pagenrs[cnt]);
-		pagelst[cnt] = page;
-		if(!PageUptodate(page)) {
-				iobuf->blocks[iobuf->nr_pages] = pagenrs[cnt];
-				iobuf->maplist[iobuf->nr_pages++] = page;
+
+/* completion handler for BIO writes */
+static int bi_write_complete(struct bio *bio, unsigned int bytes_done, int error)
+{
+	const int uptodate = test_bit(BIO_UPTODATE, &bio->bi_flags);
+	struct bio_vec *bvec = bio->bi_io_vec + bio->bi_vcnt - 1;
+
+	if (bio->bi_size)
+		return 1;
+
+	if(!uptodate)
+		err("bi_write_complete: not uptodate\n");
+
+	do {
+		struct page *page = bvec->bv_page;
+		DEBUG(3, "Cleaning up page %ld\n", page->index);
+		if (--bvec >= bio->bi_io_vec)
+			prefetchw(&bvec->bv_page->flags);
+
+		if (uptodate) {
+			SetPageUptodate(page);
+		} else {
+			ClearPageUptodate(page);
+			SetPageError(page);
 		}
+		ClearPageDirty(page);
+		unlock_page(page);
+		page_cache_release(page);
+	} while (bvec >= bio->bi_io_vec);
+	
+	complete((struct completion*)bio->bi_private);
+	return 0;
+}
+
+
+/* read one page from the block device */
+static int blkmtd_readpage(struct blkmtd_dev *dev, struct page *page)
+{
+	struct bio *bio;
+	struct completion event;
+	int err = -ENOMEM;
+
+	if(PageUptodate(page)) {
+		DEBUG(2, "blkmtd: readpage page %ld is already upto date\n", page->index);
+		unlock_page(page);
+		return 0;
 	}
+	
+	ClearPageUptodate(page);
+	ClearPageError(page);
 
-	if(iobuf->nr_pages) {
-		iobuf->length = iobuf->nr_pages << PAGE_SHIFT;
-		err = brw_kiovec(READ, 1, &iobuf, kdev, iobuf->blocks, PAGE_SIZE);
-		DEBUG(3, "blkmtd: read_pages: finished, err = %d\n", err);
-		if(err < 0) {
-			while(pages--) {
-				ClearPageUptodate(pagelst[pages]);
-				unlock_page(pagelst[pages]);
-				page_cache_release(pagelst[pages]);
-			}
-		} else {
-			while(iobuf->nr_pages--) {
-				SetPageUptodate(iobuf->maplist[iobuf->nr_pages]);
-			}
-			err = 0;
+	bio = bio_alloc(GFP_KERNEL, 1);
+	if(bio) {
+		init_completion(&event);
+		bio->bi_bdev = dev->blkdev;
+		bio->bi_sector = page->index << (PAGE_SHIFT-9);
+		bio->bi_private = &event;
+		bio->bi_end_io = bi_read_complete;
+		if(bio_add_page(bio, page, PAGE_SIZE, 0) == PAGE_SIZE) {
+			submit_bio(READ_SYNC, bio);
+			wait_for_completion(&event);
+			err = test_bit(BIO_UPTODATE, &bio->bi_flags) ? 0 : -EIO;
+			bio_put(bio);
 		}
 	}
 
+	if(err)
+		SetPageError(page);
+	else
+		SetPageUptodate(page);
+	flush_dcache_page(page);
+	unlock_page(page);
+	return err;
+}
 
-	if(iobuf != dev->rd_buf) {
-#if LINUX_VERSION_CODE < KERNEL_VERSION(2,4,4)
-		kfree(iobuf->blocks);
-#endif
-		free_kiovec(1, &iobuf);
-	} else {
-		clear_bit(0, &dev->iobuf_locks);
+
+/* write out the current BIO and wait for it to finish */
+static int blkmtd_write_out(struct bio *bio)
+{
+	struct completion event;
+	int err;
+
+	if(!bio->bi_vcnt) {
+		bio_put(bio);
+		return 0;
 	}
-	DEBUG(2, "read_pages: done, err = %d\n", err);
+
+	init_completion(&event);
+	bio->bi_private = &event;
+	bio->bi_end_io = bi_write_complete;
+	submit_bio(WRITE_SYNC, bio);
+	wait_for_completion(&event);
+	DEBUG(3, "submit_bio completed, bi_vcnt = %d\n", bio->bi_vcnt);
+	err = test_bit(BIO_UPTODATE, &bio->bi_flags) ? 0 : -EIO;
+	bio_put(bio);
 	return err;
 }
 
 
 /**
- * commit_pages - commit pages in the writeout kiobuf to disk
- * @dev: device to write to
+ * blkmtd_add_page - add a page to the current BIO
+ * @bio: bio to add to (NULL to alloc initial bio)
+ * @blkdev: block device
+ * @page: page to add
+ * @pagecnt: pages left to add
  *
- * If the current dev has pages in the dev->wr_buf kiobuf,
- * they are written to disk using brw_kiovec()
+ * Adds a page to the current bio, allocating it if necessary. If it cannot be
+ * added, the current bio is written out and a new one is allocated. Returns
+ * the new bio to add or NULL on error
  */
-static int commit_pages(struct blkmtd_dev *dev)
+static struct bio *blkmtd_add_page(struct bio *bio, struct block_device *blkdev,
+				   struct page *page, int pagecnt)
 {
-	struct kiobuf *iobuf = dev->wr_buf;
-	kdev_t kdev = to_kdev_t(dev->binding->bd_dev);
-	int err = 0;
 
-	iobuf->length = iobuf->nr_pages << PAGE_SHIFT;
-	iobuf->locked = 1;
-	if(iobuf->length) {
-		int i;
-		DEBUG(2, "blkmtd: commit_pages: nrpages = %d\n", iobuf->nr_pages);
-		/* Check all the pages are dirty and lock them */
-		for(i = 0; i < iobuf->nr_pages; i++) {
-			struct page *page = iobuf->maplist[i];
-			BUG_ON(!PageDirty(page));
-			lock_page(page);
-		}
-		err = brw_kiovec(WRITE, 1, &iobuf, kdev, iobuf->blocks, PAGE_SIZE);
-		DEBUG(3, "commit_write: committed %d pages err = %d\n", iobuf->nr_pages, err);
-		while(iobuf->nr_pages) {
-			struct page *page = iobuf->maplist[--iobuf->nr_pages];
-			ClearPageDirty(page);
-			SetPageUptodate(page);
-			unlock_page(page);
-			page_cache_release(page);
-		}
+ retry:
+	if(!bio) {
+		bio = bio_alloc(GFP_KERNEL, pagecnt);
+		if(!bio)
+			return NULL;
+		bio->bi_sector = page->index << (PAGE_SHIFT-9);
+		bio->bi_bdev = blkdev;
 	}
 
-	DEBUG(2, "blkmtd: sync: end, err = %d\n", err);
-	iobuf->offset = 0;
-	iobuf->nr_pages = 0;
-	iobuf->length = 0;
-	return err;
+	if(bio_add_page(bio, page, PAGE_SIZE, 0) != PAGE_SIZE) {
+		blkmtd_write_out(bio);
+		bio = NULL;
+		goto retry;
+	}
+	return bio;
 }
 
 
@@ -234,30 +230,25 @@
  *
  * Grab pages from the page cache and fill them with the source data.
  * Non page aligned start and end result in a readin of the page and
- * part of the page being modified. Pages are added to the wr_buf kiobuf
- * until this becomes full or the next page written to has a lower pagenr
- * then the current max pagenr in the kiobuf.
+ * part of the page being modified. Pages are added to the bio and then written
+ * out.
  */
 static int write_pages(struct blkmtd_dev *dev, const u_char *buf, loff_t to,
-		    size_t len, int *retlen)
+		    size_t len, size_t *retlen)
 {
 	int pagenr, offset;
 	size_t start_len = 0, end_len;
 	int pagecnt = 0;
-	struct kiobuf *iobuf = dev->wr_buf;
 	int err = 0;
-	struct page *pagelst[2];
-	int pagenrs[2];
-	int readpages = 0;
-	int ignorepage = -1;
+	struct bio *bio = NULL;
+	size_t thislen = 0;
 
 	pagenr = to >> PAGE_SHIFT;
 	offset = to & ~PAGE_MASK;
 
-	DEBUG(2, "blkmtd: write_pages: buf = %p to = %ld len = %d pagenr = %d offset = %d\n",
+	DEBUG(2, "blkmtd: write_pages: buf = %p to = %ld len = %zd pagenr = %d offset = %d\n",
 	      buf, (long)to, len, pagenr, offset);
 
-	*retlen = 0;
 	/* see if we have to do a partial write at the start */
 	if(offset) {
 		start_len = ((offset + len) > PAGE_SIZE) ? PAGE_SIZE - offset : len;
@@ -268,68 +259,48 @@
 	end_len = len & ~PAGE_MASK;
 	len -= end_len;
 
-	if(start_len) {
-		pagenrs[0] = pagenr;
-		readpages++;
+	if(start_len)
 		pagecnt++;
-	}
+
 	if(len)
 		pagecnt += len >> PAGE_SHIFT;
-	if(end_len) {
-		pagenrs[readpages] = pagenr + pagecnt;
-		readpages++;
-		pagecnt++;
-	}
 
-	DEBUG(3, "blkmtd: write: start_len = %d len = %d end_len = %d pagecnt = %d\n",
-	      start_len, len, end_len, pagecnt);
+	if(end_len)
+		pagecnt++;
 
 	down(&dev->wrbuf_mutex);
 
-	if(iobuf->nr_pages && ((pagenr <= iobuf->blocks[iobuf->nr_pages-1])
-			       || (iobuf->nr_pages + pagecnt) >= KIO_STATIC_PAGES)) {
-
-		if((pagenr == iobuf->blocks[iobuf->nr_pages-1])
-		   && ((iobuf->nr_pages + pagecnt) < KIO_STATIC_PAGES)) {
-			iobuf->nr_pages--;
-			ignorepage = pagenr;
-		} else {
-			DEBUG(3, "blkmtd: doing writeout pagenr = %d max_pagenr = %ld pagecnt = %d idx = %d\n",
-			      pagenr, iobuf->blocks[iobuf->nr_pages-1],
-			      pagecnt, iobuf->nr_pages);
-			commit_pages(dev);
-		}
-	}
-	
-	if(readpages) {
-		err = read_pages(dev, pagenrs, pagelst, readpages);
-		if(err < 0)
-			goto readin_err;
-	}
+	DEBUG(3, "blkmtd: write: start_len = %zd len = %zd end_len = %zd pagecnt = %d\n",
+	      start_len, len, end_len, pagecnt);
 
 	if(start_len) {
 		/* do partial start region */
 		struct page *page;
 
-		DEBUG(3, "blkmtd: write: doing partial start, page = %d len = %d offset = %d\n",
+		DEBUG(3, "blkmtd: write: doing partial start, page = %d len = %zd offset = %d\n",
 		      pagenr, start_len, offset);
-		page = pagelst[0];
+
 		BUG_ON(!buf);
-		if(PageDirty(page) && pagenr != ignorepage) {
-			err("to = %lld start_len = %d len = %d end_len = %d pagenr = %d ignorepage = %d\n",
-			    to, start_len, len, end_len, pagenr, ignorepage);
+		page = read_cache_page(dev->blkdev->bd_inode->i_mapping, pagenr, (filler_t *)blkmtd_readpage, dev);
+		lock_page(page);
+		if(PageDirty(page)) {
+			err("to = %lld start_len = %zd len = %zd end_len = %zd pagenr = %d\n",
+			    to, start_len, len, end_len, pagenr);
 			BUG();
 		}
 		memcpy(page_address(page)+offset, buf, start_len);
 		SetPageDirty(page);
 		SetPageUptodate(page);
-		unlock_page(page);
 		buf += start_len;
-		*retlen = start_len;
-		err = 0;
-		iobuf->blocks[iobuf->nr_pages] = pagenr++;
-		iobuf->maplist[iobuf->nr_pages] = page;
-		iobuf->nr_pages++;
+		thislen = start_len;
+		bio = blkmtd_add_page(bio, dev->blkdev, page, pagecnt);
+		if(!bio) {
+			err = -ENOMEM;
+			err("bio_add_page failed\n");
+			goto write_err;
+		}
+		pagecnt--;
+		pagenr++;
 	}
 
 	/* Now do the main loop to a page aligned, n page sized output */
@@ -342,12 +313,12 @@
 
 			/* see if page is in the page cache */
 			DEBUG(3, "blkmtd: write: grabbing page %d from page cache\n", pagenr);
-			page = grab_cache_page(dev->binding->bd_inode->i_mapping, pagenr);
-			if(PageDirty(page) && pagenr != ignorepage) {
+			page = grab_cache_page(dev->blkdev->bd_inode->i_mapping, pagenr);
+			if(PageDirty(page)) {
 				BUG();
 			}
 			if(!page) {
-				warn("write: cant grab cache page %d", pagenr);
+				warn("write: cannot grab cache page %d", pagenr);
 				err = -ENOMEM;
 				goto write_err;
 			}
@@ -357,50 +328,58 @@
 				memcpy(page_address(page), buf, PAGE_SIZE);
 				buf += PAGE_SIZE;
 			}
-			iobuf->blocks[iobuf->nr_pages] = pagenr++;
-			iobuf->maplist[iobuf->nr_pages] = page;
-			iobuf->nr_pages++;
+			bio = blkmtd_add_page(bio, dev->blkdev, page, pagecnt);
+			if(!bio) {
+				err = -ENOMEM;
+				err("bio_add_page failed\n");
+				goto write_err;
+			}
+			pagenr++;
+			pagecnt--;
 			SetPageDirty(page);
 			SetPageUptodate(page);
-			unlock_page(page);
 			pagesc--;
-			*retlen += PAGE_SIZE;
+			thislen += PAGE_SIZE;
 		}
 	}
 
 	if(end_len) {
 		/* do the third region */
 		struct page *page;
-		DEBUG(3, "blkmtd: write: doing partial end, page = %d len = %d\n",
+		DEBUG(3, "blkmtd: write: doing partial end, page = %d len = %zd\n",
 		      pagenr, end_len);
-		page = pagelst[readpages-1];
 		BUG_ON(!buf);
-		if(PageDirty(page) && pagenr != ignorepage) {
-			err("to = %lld start_len = %d len = %d end_len = %d pagenr = %d ignorepage = %d\n",
-			    to, start_len, len, end_len, pagenr, ignorepage);
+		page = read_cache_page(dev->blkdev->bd_inode->i_mapping, pagenr, (filler_t *)blkmtd_readpage, dev);
+		lock_page(page);
+		if(PageDirty(page)) {
+			err("to = %lld start_len = %zd len = %zd end_len = %zd pagenr = %d\n",
+			    to, start_len, len, end_len, pagenr);
 			BUG();
 		}
 		memcpy(page_address(page), buf, end_len);
 		SetPageDirty(page);
 		SetPageUptodate(page);
-		unlock_page(page);
 		DEBUG(3, "blkmtd: write: writing out partial end\n");
-		*retlen += end_len;
-		err = 0;
-		iobuf->blocks[iobuf->nr_pages] = pagenr;
-		iobuf->maplist[iobuf->nr_pages] = page;
-		iobuf->nr_pages++;
+		thislen += end_len;
+		bio = blkmtd_add_page(bio, dev->blkdev, page, pagecnt);
+		if(!bio) {
+			err = -ENOMEM;
+			err("bio_add_page failed\n");
+			goto write_err;
+		}
+		pagenr++;
 	}
 
-	DEBUG(2, "blkmtd: write: end, retlen = %d, err = %d\n", *retlen, err);
-
-	if(sync) {
-write_err:
-		commit_pages(dev);
-	}
+	DEBUG(3, "blkmtd: write: got %d vectors to write\n", bio->bi_vcnt);
+ write_err:
+	if(bio)
+		blkmtd_write_out(bio);
 
-readin_err:
+	DEBUG(2, "blkmtd: write: end, retlen = %zd, err = %d\n", *retlen, err);
 	up(&dev->wrbuf_mutex);
+
+	if(retlen)
+		*retlen = thislen;
 	return err;
 }
 
@@ -414,23 +393,15 @@
 	size_t from;
 	u_long len;
 	int err = -EIO;
-	int retlen;
-
-	/* check readonly */
-	if(!dev->wr_buf) {
-		err("error: mtd%d trying to erase readonly device %s",
-		    mtd->index, mtd->name);
-		instr->state = MTD_ERASE_FAILED;
-		goto erase_callback;
-	}
+	size_t retlen;
 
 	instr->state = MTD_ERASING;
 	from = instr->addr;
 	len = instr->len;
 
 	/* check erase region has valid start and length */
-	DEBUG(2, "blkmtd: erase: dev = `%s' from = 0x%x len = 0x%lx\n",
-	      bdevname(dev->binding->bd_dev), from, len);
+	DEBUG(2, "blkmtd: erase: dev = `%s' from = 0x%zx len = 0x%lx\n",
+	      mtd->name+9, from, len);
 	while(numregions) {
 		DEBUG(3, "blkmtd: checking erase region = 0x%08X size = 0x%X num = 0x%x\n",
 		      einfo->offset, einfo->erasesize, einfo->numblocks);
@@ -446,29 +417,25 @@
 
 	if(!numregions) {
 		/* Not a valid erase block */
-		err("erase: invalid erase request 0x%lX @ 0x%08X", len, from);
+		err("erase: invalid erase request 0x%lX @ 0x%08zX", len, from);
 		instr->state = MTD_ERASE_FAILED;
 		err = -EIO;
 	}
 
 	if(instr->state != MTD_ERASE_FAILED) {
 		/* do the erase */
-		DEBUG(3, "Doing erase from = %d len = %ld\n", from, len);
+		DEBUG(3, "Doing erase from = %zd len = %ld\n", from, len);
 		err = write_pages(dev, NULL, from, len, &retlen);
-		if(err < 0) {
+		if(err || retlen != len) {
 			err("erase failed err = %d", err);
 			instr->state = MTD_ERASE_FAILED;
 		} else {
 			instr->state = MTD_ERASE_DONE;
-			err = 0;
 		}
 	}
 
 	DEBUG(3, "blkmtd: erase: checking callback\n");
- erase_callback:
-	if (instr->callback) {
-		(*(instr->callback))(instr);
-	}
+	mtd_erase_callback(instr);
 	DEBUG(2, "blkmtd: erase: finished (err = %d)\n", err);
 	return err;
 }
@@ -482,14 +449,15 @@
 	int err = 0;
 	int offset;
 	int pagenr, pages;
-	struct page **pagelst;
-	int *pagenrs;
-	int i;
+	size_t thislen = 0;
 
-	*retlen = 0;
+	DEBUG(2, "blkmtd: read: dev = `%s' from = %lld len = %zd buf = %p\n",
+	      mtd->name+9, from, len, buf);
 
-	DEBUG(2, "blkmtd: read: dev = `%s' from = %ld len = %d buf = %p\n",
-	      bdevname(dev->binding->bd_dev), (long int)from, len, buf);
+	if(from > mtd->size)
+		return -EINVAL;
+	if(from + len > mtd->size)
+		len = mtd->size - from;
 
 	pagenr = from >> PAGE_SHIFT;
 	offset = from - (pagenr << PAGE_SHIFT);
@@ -498,48 +466,35 @@
 	DEBUG(3, "blkmtd: read: pagenr = %d offset = %d, pages = %d\n",
 	      pagenr, offset, pages);
 
-	pagelst = kmalloc(sizeof(struct page *) * pages, GFP_KERNEL);
-	if(!pagelst)
-		return -ENOMEM;
-	pagenrs = kmalloc(sizeof(int) * pages, GFP_KERNEL);
-	if(!pagenrs) {
-		kfree(pagelst);
-		return -ENOMEM;
-	}
-	for(i = 0; i < pages; i++)
-		pagenrs[i] = pagenr+i;
-
-	err = read_pages(dev, pagenrs, pagelst, pages);
-	if(err)
-		goto readerr;
-
-	pagenr = 0;
 	while(pages) {
 		struct page *page;
 		int cpylen;
 
 		DEBUG(3, "blkmtd: read: looking for page: %d\n", pagenr);
-		page = pagelst[pagenr];
+		page = read_cache_page(dev->blkdev->bd_inode->i_mapping, pagenr, (filler_t *)blkmtd_readpage, dev);
+		if(IS_ERR(page)) {
+			err = -EIO;
+			goto readerr;
+		}
 
 		cpylen = (PAGE_SIZE > len) ? len : PAGE_SIZE;
 		if(offset+cpylen > PAGE_SIZE)
 			cpylen = PAGE_SIZE-offset;
 
-		memcpy(buf + *retlen, page_address(page) + offset, cpylen);
+		memcpy(buf + thislen, page_address(page) + offset, cpylen);
 		offset = 0;
 		len -= cpylen;
-		*retlen += cpylen;
+		thislen += cpylen;
 		pagenr++;
 		pages--;
-		unlock_page(page);
 		if(!PageDirty(page))
 			page_cache_release(page);
 	}
 
  readerr:
-	kfree(pagelst);
-	kfree(pagenrs);
-	DEBUG(2, "blkmtd: end read: retlen = %d, err = %d\n", *retlen, err);
+	if(retlen)
+		*retlen = thislen;
+	DEBUG(2, "blkmtd: end read: retlen = %zd, err = %d\n", thislen, err);
 	return err;
 }
 
@@ -551,32 +506,22 @@
 	struct blkmtd_dev *dev = mtd->priv;
 	int err;
 
-	*retlen = 0;
 	if(!len)
 		return 0;
 
-	DEBUG(2, "blkmtd: write: dev = `%s' to = %ld len = %d buf = %p\n",
-	      bdevname(dev->binding->bd_dev), (long int)to, len, buf);
-
-	/* handle readonly and out of range numbers */
-
-	if(!dev->wr_buf) {
-		err("error: trying to write to a readonly device %s", mtd->name);
-		return -EROFS;
-	}
+	DEBUG(2, "blkmtd: write: dev = `%s' to = %lld len = %zd buf = %p\n",
+	      mtd->name+9, to, len, buf);
 
 	if(to >= mtd->size) {
 		return -ENOSPC;
 	}
 
 	if(to + len > mtd->size) {
-		len = (mtd->size - to);
+		len = mtd->size - to;
 	}
 
 	err = write_pages(dev, buf, to, len, retlen);
-	if(err < 0)
-		*retlen = 0;
-	else
+	if(err > 0)
 		err = 0;
 	DEBUG(2, "blkmtd: write: end, err = %d\n", err);
 	return err;
@@ -586,124 +531,22 @@
 /* sync the device - wait until the write queue is empty */
 static void blkmtd_sync(struct mtd_info *mtd)
 {
-	struct blkmtd_dev *dev = mtd->priv;
-	struct kiobuf *iobuf = dev->wr_buf;
-
-	DEBUG(2, "blkmtd: sync: called\n");
-	if(iobuf == NULL)
-		return;
-
-	DEBUG(3, "blkmtd: kiovec: length = %d nr_pages = %d\n",
-	      iobuf->length, iobuf->nr_pages);
-	down(&dev->wrbuf_mutex);
-	if(iobuf->nr_pages)
-		commit_pages(dev);
-	up(&dev->wrbuf_mutex);
+	/* Currently all writes are synchronous */
 }
 
 
-#ifdef BLKMTD_PROC_DEBUG
-/* procfs stuff */
-static int blkmtd_proc_read(char *page, char **start, off_t off,
-			    int count, int *eof, void *data)
-{
-	int len;
-	struct list_head *temp1, *temp2;
-
-	MOD_INC_USE_COUNT;
-
-	/* Count the size of the page lists */
-
-	len = sprintf(page, "dev\twr_idx\tmax_idx\tnrpages\tclean\tdirty\tlocked\tlru\n");
-	list_for_each_safe(temp1, temp2, &blkmtd_device_list) {
-		struct blkmtd_dev *dev = list_entry(temp1,  struct blkmtd_dev,
-						    list);
-		struct list_head *temp;
-		struct page *pagei;
-
-		int clean = 0, dirty = 0, locked = 0, lru = 0;
-		/* Count the size of the page lists */
-		list_for_each(temp, &dev->binding->bd_inode->i_mapping->clean_pages) {
-			pagei = list_entry(temp, struct page, list);
-			clean++;
-			if(PageLocked(pagei))
-				locked++;
-			if(PageDirty(pagei))
-				dirty++;
-			if(PageLRU(pagei))
-				lru++;
-		}
-		list_for_each(temp, &dev->binding->bd_inode->i_mapping->dirty_pages) {
-			pagei = list_entry(temp, struct page, list);
-			if(PageLocked(pagei))
-				locked++;
-			if(PageDirty(pagei))
-				dirty++;
-			if(PageLRU(pagei))
-				lru++;
-		}
-		list_for_each(temp, &dev->binding->bd_inode->i_mapping->locked_pages) {
-			pagei = list_entry(temp, struct page, list);
-			if(PageLocked(pagei))
-				locked++;
-			if(PageDirty(pagei))
-				dirty++;
-			if(PageLRU(pagei))
-				lru++;
-		}
-
-		len += sprintf(page+len, "mtd%d:\t%ld\t%d\t%ld\t%d\t%d\t%d\t%d\n",
-			       dev->mtd_info.index,
-			       (dev->wr_buf && dev->wr_buf->nr_pages) ?
-			       dev->wr_buf->blocks[dev->wr_buf->nr_pages-1] : 0,
-			       (dev->wr_buf) ? dev->wr_buf->nr_pages : 0,
-			       dev->binding->bd_inode->i_mapping->nrpages,
-			       clean, dirty, locked, lru);
-	}
-
-	if(len <= count)
-		*eof = 1;
-
-	MOD_DEC_USE_COUNT;
-	return len;
-}
-#endif
-
-
 static void free_device(struct blkmtd_dev *dev)
 {
 	DEBUG(2, "blkmtd: free_device() dev = %p\n", dev);
 	if(dev) {
-		del_mtd_device(&dev->mtd_info);
-		info("mtd%d: [%s] removed", dev->mtd_info.index,
-		     dev->mtd_info.name + strlen("blkmtd: "));
 		if(dev->mtd_info.eraseregions)
 			kfree(dev->mtd_info.eraseregions);
 		if(dev->mtd_info.name)
 			kfree(dev->mtd_info.name);
 
-		if(dev->rd_buf) {
-			dev->rd_buf->locked = 0;
-#if LINUX_VERSION_CODE < KERNEL_VERSION(2,4,4)
-			if(dev->rd_buf->blocks)
-				kfree(dev->rd_buf->blocks);
-#endif
-			free_kiovec(1, &dev->rd_buf);
-		}
-		if(dev->wr_buf) {
-			dev->wr_buf->locked = 0;
-#if LINUX_VERSION_CODE < KERNEL_VERSION(2,4,4)			
-			if(dev->wr_buf->blocks)
-				kfree(dev->rw_buf->blocks);
-#endif
-			free_kiovec(1, &dev->wr_buf);
-		}
-
-		if(dev->binding) {
-			kdev_t kdev = to_kdev_t(dev->binding->bd_dev);
-			invalidate_inode_pages(dev->binding->bd_inode);
-			set_blocksize(kdev, 1 << 10);
-			blkdev_put(dev->binding, BDEV_RAW);
+		if(dev->blkdev) {
+			invalidate_inode_pages(dev->blkdev->bd_inode->i_mapping);
+			close_bdev_excl(dev->blkdev);
 		}
 		kfree(dev);
 	}
@@ -720,7 +563,7 @@
 {
 	struct mtd_erase_region_info *info = NULL;
 
-	DEBUG(2, "calc_erase_regions, es = %d size = %d regions = %d\n",
+	DEBUG(2, "calc_erase_regions, es = %zd size = %zd regions = %d\n",
 	      erase_size, total_size, *regions);
 	/* Make any user specified erasesize be a power of 2
 	   and at least PAGE_SIZE */
@@ -768,119 +611,62 @@
 				break;
 		}
 	} while(!(*regions));
-	DEBUG(2, "calc_erase_regions done, es = %d size = %d regions = %d\n",
+	DEBUG(2, "calc_erase_regions done, es = %zd size = %zd regions = %d\n",
 	      erase_size, total_size, *regions);
 	return info;
 }
 
 
-extern kdev_t name_to_kdev_t(char *line) __init;
-
+extern dev_t __init name_to_dev_t(const char *line);
 
 static struct blkmtd_dev *add_device(char *devname, int readonly, int erase_size)
 {
-	int maj, min;
-	kdev_t kdev;
+	struct block_device *bdev;
 	int mode;
 	struct blkmtd_dev *dev;
 
-#ifdef MODULE
-	struct file *file = NULL;
-	struct inode *inode;
-#endif
-
 	if(!devname)
 		return NULL;
 
 	/* Get a handle on the device */
-	mode = (readonly) ? O_RDONLY : O_RDWR;
 
-#ifdef MODULE
 
-	file = filp_open(devname, mode, 0);
-	if(IS_ERR(file)) {
-		err("error: cant open device %s", devname);
-		DEBUG(2, "blkmtd: filp_open returned %ld\n", PTR_ERR(file));
-		return NULL;
-	}
-
-	/* determine is this is a block device and
-	 * if so get its major and minor numbers
-	 */
-	inode = file->f_dentry->d_inode;
-	if(!S_ISBLK(inode->i_mode)) {
-		err("%s not a block device", devname);
-		filp_close(file, NULL);
-		return NULL;
-	}
-	kdev = inode->i_rdev;
-	filp_close(file, NULL);
+#ifdef MODULE
+	mode = (readonly) ? O_RDONLY : O_RDWR;
+	bdev = open_bdev_excl(devname, mode, NULL);
 #else
-	kdev = name_to_kdev_t(devname);
-#endif	/* MODULE */
-
-	if(!kdev) {
-		err("bad block device: `%s'", devname);
+	mode = (readonly) ? FMODE_READ : FMODE_WRITE;
+	bdev = open_by_devnum(name_to_dev_t(devname), mode);
+#endif
+	if(IS_ERR(bdev)) {
+		err("error: cannot open device %s", devname);
+		DEBUG(2, "blkmtd: opening bdev returned %ld\n", PTR_ERR(bdev));
 		return NULL;
 	}
 
-	maj = MAJOR(kdev);
-	min = MINOR(kdev);
 	DEBUG(1, "blkmtd: found a block device major = %d, minor = %d\n",
-	      maj, min);
+	      MAJOR(bdev->bd_dev), MINOR(bdev->bd_dev));
 
-	if(maj == MTD_BLOCK_MAJOR) {
+	if(MAJOR(bdev->bd_dev) == MTD_BLOCK_MAJOR) {
 		err("attempting to use an MTD device as a block device");
+		blkdev_put(bdev);
 		return NULL;
 	}
 
-	DEBUG(1, "blkmtd: devname = %s\n", bdevname(kdev));
-
 	dev = kmalloc(sizeof(struct blkmtd_dev), GFP_KERNEL);
-	if(dev == NULL)
+	if(dev == NULL) {
+		blkdev_put(bdev);
 		return NULL;
+	}
 
 	memset(dev, 0, sizeof(struct blkmtd_dev));
-	if(alloc_kiovec(1, &dev->rd_buf)) {
-		err("cant allocate read iobuf");
-		goto devinit_err;
-	}
-#if LINUX_VERSION_CODE < KERNEL_VERSION(2,4,4)
-	dev->rd_buf->blocks = kmalloc(KIO_MAX_SECTORS * sizeof(unsigned long), GFP_KERNEL);
-	if(dev->rd_buf->blocks == NULL) {
-		crit("cant allocate rd_buf blocks");
-		goto devinit_err;
-	}
-#endif
-	
+	dev->blkdev = bdev;
+	atomic_set(&(dev->blkdev->bd_inode->i_mapping->truncate_count), 0);
 	if(!readonly) {
-		if(alloc_kiovec(1, &dev->wr_buf)) {
-			err("cant allocate kiobuf - readonly enabled");
-
-#if LINUX_VERSION_CODE < KERNEL_VERSION(2,4,4)
-		} else {
-			dev->wr_buf->blocks = kmalloc(KIO_MAX_SECTORS * sizeof(unsigned long), GFP_KERNEL);
-			if(dev->wr_buf->blocks == NULL) {
-				crit("cant allocate wr_buf blocks - readonly enabled");
-				free_kiovec(1, &iobuf);
-			}
-#endif
-		}
-		if(dev->wr_buf)
-			init_MUTEX(&dev->wrbuf_mutex);
-	}
-
-	/* get the block device */
-	dev->binding = bdget(kdev_t_to_nr(MKDEV(maj, min)));
-	if(blkdev_get(dev->binding, mode, 0, BDEV_RAW))
-		goto devinit_err;
-
-	if(set_blocksize(kdev, PAGE_SIZE)) {
-		err("cant set block size to PAGE_SIZE on %s", bdevname(kdev));
-		goto devinit_err;
+		init_MUTEX(&dev->wrbuf_mutex);
 	}
 
-	dev->mtd_info.size = dev->binding->bd_inode->i_size & PAGE_MASK;
+	dev->mtd_info.size = dev->blkdev->bd_inode->i_size & PAGE_MASK;
 
 	/* Setup the MTD structure */
 	/* make the name contain the block device in */
@@ -904,27 +690,26 @@
 	} else {
 		dev->mtd_info.type = MTD_RAM;
 		dev->mtd_info.flags = MTD_CAP_RAM;
+		dev->mtd_info.erase = blkmtd_erase;
+		dev->mtd_info.write = blkmtd_write;
+		dev->mtd_info.writev = default_mtd_writev;
+		dev->mtd_info.sync = blkmtd_sync;
 	}
-	dev->mtd_info.erase = blkmtd_erase;
 	dev->mtd_info.read = blkmtd_read;
-	dev->mtd_info.write = blkmtd_write;
-	dev->mtd_info.sync = blkmtd_sync;
-	dev->mtd_info.point = 0;
-	dev->mtd_info.unpoint = 0;
+	dev->mtd_info.readv = default_mtd_readv;
 	dev->mtd_info.priv = dev;
-	dev->mtd_info.module = THIS_MODULE;
+	dev->mtd_info.owner = THIS_MODULE;
 
 	list_add(&dev->list, &blkmtd_device_list);
 	if (add_mtd_device(&dev->mtd_info)) {
 		/* Device didnt get added, so free the entry */
 		list_del(&dev->list);
-		free_device(dev);
-		return NULL;
+		goto devinit_err;
 	} else {
 		info("mtd%d: [%s] erase_size = %dKiB %s",
 		     dev->mtd_info.index, dev->mtd_info.name + strlen("blkmtd: "),
 		     dev->mtd_info.erasesize >> 10,
-		     (dev->wr_buf) ? "" : "(read-only)");
+		     readonly ? "(read-only)" : "");
 	}
 	
 	return dev;
@@ -939,17 +724,16 @@
 static void __devexit cleanup_blkmtd(void)
 {
 	struct list_head *temp1, *temp2;
-#ifdef BLKMTD_PROC_DEBUG
-	if(blkmtd_proc) {
-		remove_proc_entry("blkmtd_debug", NULL);
-	}
-#endif
 
 	/* Remove the MTD devices */
 	list_for_each_safe(temp1, temp2, &blkmtd_device_list) {
 		struct blkmtd_dev *dev = list_entry(temp1, struct blkmtd_dev,
 						    list);
 		blkmtd_sync(&dev->mtd_info);
+		del_mtd_device(&dev->mtd_info);
+		info("mtd%d: [%s] removed", dev->mtd_info.index,
+		     dev->mtd_info.name + strlen("blkmtd: "));
+		list_del(&dev->list);
 		free_device(dev);
 	}
 }
@@ -1020,6 +804,7 @@
 {
 	int i;
 
+	info("version " VERSION);
 	/* Check args - device[0] is the bare minimum*/
 	if(!device[0]) {
 		err("error: missing `device' name\n");
@@ -1030,28 +815,9 @@
 		add_device(device[i], ro[i], erasesz[i] << 10);
 
 	if(list_empty(&blkmtd_device_list))
-		goto init_err;
-
-	info("version " VERSION);
-
-#ifdef BLKMTD_PROC_DEBUG
-	/* create proc entry */
-	DEBUG(2, "Creating /proc/blkmtd_debug\n");
-	blkmtd_proc = create_proc_read_entry("blkmtd_debug", 0444,
-					     NULL, blkmtd_proc_read, NULL);
-	if(blkmtd_proc == NULL) {
-		err("Cant create /proc/blkmtd_debug");
-	} else {
-		blkmtd_proc->owner = THIS_MODULE;
-	}
-#endif
-
-	if(!list_empty(&blkmtd_device_list))
-		/* Everything is ok if we got here */
-		return 0;
+		return -EINVAL;
 
- init_err:
-	return -EINVAL;
+	return 0;
 }
 
 module_init(init_blkmtd);
Index: drivers/mtd/devices/doc1000.c
===================================================================
RCS file: /cvsroot/ts-7200/dist/linux24/drivers/mtd/devices/doc1000.c,v
retrieving revision 1.1
retrieving revision 1.2
diff -u -r1.1 -r1.2
--- drivers/mtd/devices/doc1000.c	22 Jul 2004 19:49:46 -0000	1.1
+++ drivers/mtd/devices/doc1000.c	4 Aug 2004 01:29:05 -0000	1.2
@@ -1,6 +1,6 @@
 /*======================================================================
 
-  $Id: doc1000.c,v 1.1 2004/07/22 19:49:46 joff Exp $
+  $Id: doc1000.c,v 1.2 2004/08/04 01:29:05 joff Exp $
 
 ======================================================================*/
 
